<?php
define('USERS_CAT_ID', 19);
define('THREADS_CAT_ID', 20);
define('POSTINGS_CAT_ID', 21);

// The session user-ID (created by Frontainer)
$userid = (!empty($_SESSION['userid']) ? (int) $_SESSION['userid'] : false);
//$userid = 3;

$categories = array(
	'tablets' =>
		array(
			'title' => 'Tablet computers',
			'descr' => 'Questions and discussions about tablet computers.'
		),
	'readers' =>
		array(
			'title' => 'E-Book readers',
			'descr' => 'Questions and discussions about E-Book readers and downloadable books'
		),
	'phones' =>
		array(
			'title' => 'Smartphones',
			'descr' => 'Questions and discussions about smartphones, applications etc.'
		),
);

$errors = '';
$msgs = '';
$user_posting_ids = array();
$postings = false;
$post_category = !empty($_POST['category']) ?
	htmlspecialchars($_POST['category'], ENT_QUOTES, 'UTF-8', false) : '';
$post_title = !empty($_POST['title']) ?
	substr(htmlspecialchars($_POST['title'], ENT_QUOTES, 'UTF-8', false), 0, 80) : '';
$post_content = !empty($_POST['content']) ?
	substr(htmlspecialchars($_POST['content'], ENT_QUOTES, 'UTF-8', false), 0, 1000) : '';
$threadid = !empty($_POST['threadid']) ? (int) $_POST['threadid'] : null;
if(is_null($threadid) && !empty($_GET['threadid'])) $threadid = (int) $_GET['threadid'];
$postid = !empty($_GET['postid']) ? (int) $_GET['postid'] : null;
// Just an success flag after redirection on 'save' a new thread
$msgs = ((!empty($_GET['f']) && (int) $_GET['f'] == 1) ? '<li>Item has been successfully saved</li>' : '');

$imanager = new IManager();
$itemMapper = $imanager->getItemClass();
$categoryMapper = $imanager->getCategoryClass();
$cache = $imanager->getSectionCache();

$slug = (string) get_page_slug(false);

if($slug == 'edit' && !empty($_POST['send']) && !empty($userid)){saveThread();}

if($slug == 'post' && !is_null($threadid) && !empty($userid) && !empty($_POST['send'])){savePost();}


function saveThread()
{
	global $imanager,
		   $itemMapper,
	       $cache,
		   $errors,
		   $msgs,
		   $post_category,
		   $post_title,
		   $post_content,
		   $threadid,
		   $userid;

	// Check user input
	if(empty($post_category))
	{
		$errors = '<li>Please select a category</li>';
	} elseif(!in_array($post_category, getCategoryParams('title')))
	{
		$errors .= '<li>Unknown category</li>';
	}
	if(empty($post_title))
	{
		$errors .= '<li>Please enter a short title for the thread</li>';
	}
	if(empty($post_content))
	{
		$errors .= '<li>Please complete the content of the thread.</li>';
	}

	if(!empty($errors)) return false;

	// Create new thread
	if(empty($threadid))
	{
		if(!$itemMapper->maxItemsExceeded(THREADS_CAT_ID, 15))
		{
			$errors .= '<li>The maximum number of entries is reached.</li>';
			return false;
		}
		$newThread = $imanager->newItem(THREADS_CAT_ID);
		$newThread->name = $post_title;
		$newThread->setFieldValue('category', $post_category);
		$newThread->setFieldValue('user_id', $userid);
		$newThread->setFieldValue('content', $post_content);
		$newThread->active = 1;
		// save item
		if(!$newThread->save())
		{
			$errors .= '<li>An error occurred when saving the item.</li>';
		} else {
			$cache->expire();
			$threadid = $newThread->get('id');
			header('Location: ./?threadid='.$threadid.'&f=1');
			die();
		}
	// Edit old thread
	} else
	{
		// ID passed belongs really to the thread creater?
		$itemMapper->limitedInit(THREADS_CAT_ID, $threadid);
		$thread = (!empty($itemMapper->items[$threadid]) ? $itemMapper->items[$threadid] : false);

		if(!empty($thread) && $thread->fields->user_id->value == $userid)
		{
			$thread->name = $post_title;
			$thread->setFieldValue('category', $post_category);
			$thread->setFieldValue('user_id', $userid);
			$thread->setFieldValue('content', $post_content);
			$thread->active = 1;
			// save item
			if(!$thread->save())
			{
				$errors .= '<li>An error occurred when saving the item.</li>';
			} else {
				$cache->expire();
				$msgs = '<li>Item has been successfully saved</li>';
			}
		}
	}
}



function savePost()
{
	global $imanager,
		   $itemMapper,
		   $cache,
		   $errors,
		   $msgs,
		   $post_content,
		   $threadid,
		   $userid,
		   $postid,
		   $categories,
		   $user_posting_ids,
		   $postings;

	// Get thread object
	$itemMapper->limitedInit(THREADS_CAT_ID, $threadid);
	$thread = (!empty($itemMapper->items[$threadid]) ? $itemMapper->items[$threadid] : false);
	if(empty($thread)) $errors .= '<li>Thread not found</li>';
	$itemMapper->init(POSTINGS_CAT_ID);
	// is this post ID identical to users ID
	$itemMapper->getItems('user_id='.$userid);
	$user_posting_ids = array();
	if(!empty($itemMapper->items))
	{
		foreach($itemMapper->items as $item)
		{
			$user_posting_ids[] =  $item->get('id');
		}
	}
	$itemMapper->limitedInit(USERS_CAT_ID, $thread->fields->user_id->value);

	// Check user sent content
	if(empty($post_content)) {
		$errors .= '<li>Please complete the content of the post.</li>';
	}

	if(!empty($errors)) return false;

	// Create new post
	if(empty($postid))
	{
		if(!$itemMapper->maxItemsExceeded(POSTINGS_CAT_ID, 30))
		{
			$errors .= '<li>The maximum number of entries is reached.</li>';
			return false;
		}
		$newPost = $imanager->newItem(POSTINGS_CAT_ID);
		$newPost->name = htmlspecialchars($thread->name, ENT_QUOTES, 'UTF-8', false);
		$newPost->setFieldValue('thread_id', $threadid);
		$newPost->setFieldValue('user_id', $userid);
		$newPost->setFieldValue('content', $post_content);
		$newPost->active = 1;
		// save item
		if(!$newPost->save())
		{
			$errors .= '<li>An error occurred when saving the item.</li>';
		} else {
			$postid = $newPost->get('id');
			$msgs = '<li>Item has been successfully saved</li>';
			// empty cache
			$cache->expire();
			// reinit the postings
			header('Location: ./?threadid='.$threadid.'&postid='.$postid.'&f=1');
			die();
		}
	// Edit an older post
	} else
	{
		if(!empty($postid) && in_array($postid, $user_posting_ids))
		{
			$itemMapper->limitedInit(POSTINGS_CAT_ID, $postid);
			$oldPost = (!empty($itemMapper->items[$postid]) ? $itemMapper->items[$postid] : false);
			if(!empty($oldPost))
			{
				$oldPost->name = htmlspecialchars($thread->name, ENT_QUOTES, 'UTF-8', false);
				$oldPost->setFieldValue('thread_id', $threadid);
				$oldPost->setFieldValue('user_id', $userid);
				$oldPost->setFieldValue('content', $post_content);
				$oldPost->active = 1;
				// save item
				if(!$oldPost->save())
				{
					$errors .= '<li>An error occurred when saving the item.</li>';
				} else {
					$msgs = '<li>Item has been successfully saved</li>';
					$cache->expire();
				}
			}
		}
	}
}



function getCurrentCatLink($pat)
{
	global $categories;
	foreach($categories as $cat_slug => $cat)
	{
		if($cat['title'] == $pat)
		{
			return $cat_slug;
		}
	}
}


function getCategoryParams($parName)
{
	global $categories;
	$arr = array();
	foreach($categories as $c)
	{
		$arr[] = $c[$parName];
	}
	return $arr;
}